--[[

This code is MIT licensed, see http://www.opensource.org/licenses/mit-license.php
(C) 2010 - 2011 Gideros Mobile 

]]

require "box2d"

--b2.setScale(20)

--local sky = Bitmap.new(Texture.new("sky.png"))
--stage:addChild(sky)

--local grass = Bitmap.new(Texture.new("grass.png"))
--grass:setY(400)
--stage:addChild(grass)
application:setBackgroundColor(0x000000)

-- this table holds the dynamic bodies and their sprites
local actors = {}

-- create world
local world = b2.World.new(0, 0, false)

local debugDraw = b2.DebugDraw.new()
world:setDebugDraw(debugDraw)
	
	
-- this function creates a 80x80 physical box and adds it to the stage
local function createBox(x, y, name)
	
	local body = world:createBody{type = b2.DYNAMIC_BODY, position = {x = x, y = y}}
	
	body.name = name
	body.speed = 3

	local shape = b2.PolygonShape.new()
	shape:setAsBox(40, 40)
	body:createFixture{shape = shape, density = 0, restitution = 0, friction = 0}
	
	local sprite = Bitmap.new(Texture.new("box.png"))
	sprite:setAnchorPoint(0.5, 0.5)
	stage:addChild(sprite)
	
	sprite:addEventListener(Event.ENTER_FRAME, function()
		
		local px, py = body:getPosition()
		local lx, ly = body:getLinearVelocity()
		
		if px > 440 or px < 20 then
		
			body.speed = -body.speed
		
		end
		
		body:setLinearVelocity(body.speed, ly)
		--body:setLinearVelocity(0, body.speed)
		
	end)
	
	actors[body] = sprite
end

--createBox(140, -30, "box1")
createBox(20, 50, "box2")
stage:addChild(debugDraw)

-- step the world and then update the position and rotation of sprites
local function onEnterFrame()
	
	world:step(1/60, 8, 3)
	
	for body,sprite in pairs(actors) do
		sprite:setPosition(body:getPosition())
		sprite:setRotation(body:getAngle() * 180 / math.pi)
	end
end

stage:addEventListener(Event.ENTER_FRAME, onEnterFrame)
